{$B-}
unit KA.Data.KADao.Info;
//******************************************************************************
//                         Delphi Dao Project
//                 Copyright (c) 2000 by Kiril Antonov
//******************************************************************************
interface

uses
  Borland.Vcl.SysUtils,
  Borland.Vcl.Classes,
  Borland.Vcl.Controls,
  Borland.Vcl.Forms,
  Borland.Vcl.WinUtils,
  Borland.Vcl.Dialogs;

type
  TInfoCheckEvent = Procedure of object;
  TKADaoInfo = class(TComponent)
  private
  protected
    { Protected declarations }
    FActive             : Boolean;
    FDatabase           : String;
    FDatabaseVersion    : Integer;
    FNumberOfUsers      : Integer;
    FLoggedUsers        : TStringList;
    FLoggedInfo         : TStringList;
    FLoggedNowUsers     : TStringList;
    FErrorUsers         : TStringList;
    FLastError          : Integer;
    FLastErrorText      : String;

    FAfterGetDatabaseVersion : TInfoCheckEvent;
    FAfterGetNumberOfUsers   : TInfoCheckEvent;
    FAfterGetLoggedUsers     : TInfoCheckEvent;
    FAfterGetLoggedUsersEx   : TInfoCheckEvent;
    FAfterGetLoggedNowUsers  : TInfoCheckEvent;
    FAfterGetErrorUsers      : TInfoCheckEvent;

    Procedure SetActive(Value:Boolean);

    Function  GetLoggedUsers : TStringList;
    Procedure SetLoggedUsers(Value:TStringList);

    Function  GetLoggedUsersEx : TStringList;
    Procedure SetLoggedUsersEx(Value:TStringList);

    Function  GetLoggedNowUsers : TStringList;
    Procedure SetLoggedNowUsers(Value:TStringList);

    Function  GetErrorUsers : TStringList;
    Procedure SetErrorUsers(Value:TStringList);

    Function  GetDatabaseVersion :Integer;
    Procedure SetDatabaseVersion (Value:Integer);

    Function  GetNumberOfUsers :Integer;
    Procedure SetNumberOfUsers (Value:Integer);

    Procedure SetLastError(Value:Integer);
    Procedure SetLastErrorText(Value:String);

  public
    { Public declarations }
    Constructor   Create(AOwner: TComponent); override;
    Destructor    Destroy; override;

    Function KAGetDatabaseVersion(DatabasePath:String):Integer;
    Function KAGetNumberOfUsers(DatabasePath:String):Integer;
    Function KAGetLoggedUsersEx(DatabasePath:String; Which:Integer;List : TStringList):Integer;
    Function KAGetLoggedUsers(DatabasePath:String):Integer;
    Function KAGetLoggedNowUsers(DatabasePath:String):Integer;
    Function KAGetErrorUsers(DatabasePath:String):Integer;
    Function KAGetLoggedInfo(DatabasePath:String):Boolean;

  published
    { Published declarations }
    Property Database                  : String        Read FDatabase                Write FDatabase;
    Property DatabaseVersion           : Integer       Read GetDatabaseVersion       Write SetDatabaseVersion;
    Property NumberOfUsers             : Integer       Read GetNumberOfUsers         Write SetNumberOfUsers;
    Property LoggedUsers               : TStringList   Read GetLoggedUsers           Write SetLoggedUsers;
    Property LoggedUsersEx             : TStringList   Read GetLoggedUsersEx         Write SetLoggedUsersEx;
    Property LoggedNowUsers            : TStringList   Read GetLoggedNowUsers        Write SetLoggedNowUsers;
    Property ErrorUsers                : TStringList   Read GetErrorUsers            Write SetErrorUsers;
    Property LastError                 : Integer       Read FLastError               Write SetLastError;
    Property LastErrorText             : String        Read FLastErrorText           Write SetLastErrorText;
    Property AfterGetDatabaseVersion : TInfoCheckEvent Read FAfterGetDatabaseVersion Write FAfterGetDatabaseVersion;
    Property AfterGetNumberOfUsers   : TInfoCheckEvent Read FAfterGetNumberOfUsers   Write FAfterGetNumberOfUsers;
    Property AfterGetLoggedUsers     : TInfoCheckEvent Read FAfterGetLoggedUsers     Write FAfterGetLoggedUsers;
    Property AfterGetLoggedUsersEx   : TInfoCheckEvent Read FAfterGetLoggedUsersEx   Write FAfterGetLoggedUsersEx;
    Property AfterGetLoggedNowUsers  : TInfoCheckEvent Read FAfterGetLoggedNowUsers  Write FAfterGetLoggedNowUsers;
    Property AfterGetErrorUsers      : TInfoCheckEvent Read FAfterGetErrorUsers      Write FAfterGetErrorUsers;

    Property Active                  : Boolean       Read FActive                    Write SetActive;
  end;

procedure Register;

implementation
Uses
  System.Text,
  System.Runtime.InteropServices,
  Borland.Vcl.Windows,
  Borland.Vcl.Variants,
  Borland.Vcl.ActiveX,
  KA.Data.KADao.DaoUtils;

[DllImport('msldbusr.dll', CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi, SetLastError = True, EntryPoint = 'LDBUser_GetError')]
Function MSGetLastError(ErrorNo: Integer):StringBuilder;external;

[DllImport('msldbusr.dll', CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi, SetLastError = True, EntryPoint = 'LDBUser_GetDatabaseVersion')]
Function MSGetDatabaseVersion(DBPath: String):Integer;external;

[DllImport('msldbusr.dll', CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi, SetLastError = True, EntryPoint = 'LDBUser_GetUsers')]
Function MSGetNumberOfUsers(UserBuffer : IntPtr; DBPath:String; Options:Integer):Integer;external;

[DllImport('msldbusr.dll', CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi, SetLastError = True, EntryPoint = 'LDBUser_GetUsers')]
Function MSGetUsers(Var UserBuffer : IntPtr; DBPath:String; Options:Integer):Integer;external;

{$WARNINGS OFF}
type
  TOleVarData = packed record
    case Integer of
      0: (VT: Int16;
          _Reserved1: Int16;
          _Reserved2: Int32;
          case Integer of
            VT_UI1:  (bVal: Byte);
            VT_I2:   (iVal: Smallint);
            VT_I4:   (lVal: Longint);
            VT_R4:   (fltVal: Single);
            VT_R8:   (dblVal: Int64);     { Double }
            VT_BOOL: (vBool: WordBool);
            VT_CY:   (cyVal: TOACurrency);
            VT_DATE: (vDate: Int64);      { Double, TOleDate }
            VT_BSTR: (bStrVal: IntPtr);   { PWideChar, WideString }
            VT_I1:   (cVal: ShortInt);
            VT_UI2:  (uiVal: Word);
            VT_UI4:  (ulVal: LongWord);
            VT_INT:  (intVal: Integer);
            VT_I8:   (int64Val: Int64);
            VT_ARRAY:(pArray: PSafeArray)
         );
      1: (Reserved1: Int64; Reserved2: Int64);
  end;
{$WARNINGS ON}

function OleVarDataToVariant(OleVarData: TOleVarData): Variant;
var
  Buffer: IntPtr;
begin
  Buffer := Marshal.AllocHGlobal(Marshal.SizeOf(TypeOf(TOleVarData)));
  try
    Marshal.StructureToPtr(OleVarData, Buffer, False);
    Result := Variant(Marshal.GetObjectForNativeVariant(Buffer));
  finally
    Marshal.FreeHGlobal(Buffer);
  end;
end;


Constructor TKADaoInfo.Create(AOwner: TComponent);
var
   Tmp : String;
Begin
  Inherited Create(AOwner);
  FActive             := False;
  FDatabase           := '';
  FDatabaseVersion    := 0;
  FNumberOfUsers      := 0;
  FLoggedUsers        := TStringList.Create;
  FLoggedInfo         := TStringList.Create;
  FLoggedNowUsers     := TStringList.Create;
  FErrorUsers         := TStringList.Create;
  FLastError          := 0;
  FLastErrorText      := '';
  GetDir(0,Tmp);
End;

Destructor TKADaoInfo.Destroy;
Begin
  FLoggedUsers.Free;
  FLoggedInfo.Free;
  FLoggedNowUsers.Free;
  FErrorUsers.Free;
  Inherited Destroy;
End;

Procedure TKADaoInfo.SetActive(Value:Boolean);
Begin
 FActive := Value;
 if FActive Then
    Begin
      KAGetDatabaseVersion(FDatabase);
      if Assigned(FAfterGetDatabaseVersion) Then FAfterGetDatabaseVersion;
      KAGetNumberOfUsers(FDatabase);
      if Assigned(FAfterGetNumberOfUsers) Then FAfterGetNumberOfUsers;
      KAGetLoggedUsers(FDatabase);
      if Assigned(FAfterGetLoggedUsers) Then FAfterGetLoggedUsers;
      KAGetLoggedNowUsers(FDatabase);
      if Assigned(FAfterGetLoggedNowUsers) Then FAfterGetLoggedNowUsers;
      KAGetErrorUsers(FDatabase);
      if Assigned(FAfterGetErrorUsers) Then FAfterGetErrorUsers;
      KAGetLoggedInfo(FDatabase);
      if Assigned(FAfterGetLoggedUsersEx) Then FAfterGetLoggedUsersEx;
    End;
End;

Function TKADaoInfo.KAGetDatabaseVersion(DatabasePath:String):Integer;
Begin
  Result := 0;
 Try
  Result := MSGetDatabaseVersion(DatabasePath);
  if Result < 0 Then
     Begin
       FLastError     := Result;
       FLastErrorText := MSGetLastError(FLastError).ToString;
     End;
  Except
  End;
End;

Function TKADaoInfo.KAGetNumberOfUsers(DatabasePath:String):Integer;
Begin
 Result := 0;
 Try
  Result := MSGetNumberOfUsers(Nil,DatabasePath,8);
  if Result < 0 Then
     Begin
       FLastError     := Result;
       FLastErrorText := MSGetLastError(FLastError).ToString;
     End;
 Except
 End;
End;

Function TKADaoInfo.KAGetLoggedUsersEx(DatabasePath:String; Which:Integer; List : TStringList):Integer;
Var
  X            : Integer;
  Bounds       : array of Integer;
  NumUsers     : Integer;
  UserList     : PSafeArray;
  VA           : TOleVarData;
  V            : OleVariant;
  S            : String;
Begin
 Result := 0;
 Try
  List.Clear;
  SetLength(Bounds, 2);
  Bounds[0] := 1;
  Bounds[1] := 1;
  UserList  := SafeArrayCreate(VT_BSTR, 1, Bounds);
  Try
    VA.VT     := VT_ARRAY OR VT_BSTR;
    VA.pArray := UserList;
    NumUsers  := MSGetUsers(UserList,DatabasePath,Which);
    if NumUsers > 0 Then
       Begin
         V         := OleVarDataToVariant(VA);
         For X := 1 To NumUsers do
             Begin
               S  := AnsiEncoding.GetString(Encoding.Unicode.GetBytes(V[X]));
               Borland.Delphi.System.Delete(S,Length(S),1);
               List.Add(S);
             End;
       End
    Else
    if NumUsers < 0 Then
       Begin
         FLastError     := Result;
         FLastErrorText := MSGetLastError(FLastError).ToString;
       End;
    Result := NumUsers;
  Finally
    SafeArrayDestroy(UserList);
  End;
 Except
 End;
End;

Function TKADaoInfo.KAGetLoggedUsers(DatabasePath:String):Integer;
Begin
  //1
  Result := KAGetLoggedUsersEx(DatabasePath,1,FLoggedUsers);
End;


Function TKADaoInfo.KAGetLoggedNowUsers(DatabasePath:String):Integer;
Begin
 //2
 Result := KAGetLoggedUsersEx(DatabasePath,2,FLoggedNowUsers);
End;


Function TKADaoInfo.KAGetErrorUsers(DatabasePath:String):Integer;
Begin
 //4
 Result := KAGetLoggedUsersEx(DatabasePath,4,FErrorUsers);
End;

Function TKADaoInfo.KAGetLoggedInfo(DatabasePath:String):Boolean;
Var
  FP  : String;
  FN  : String;
  S   : String;
  F   : TFileStream;
  Tmp : Array of Byte;
  Sz  : Integer;
  X   : Integer;
  I   : Integer;
Begin
  Result := False;
  FLoggedInfo.Clear;
  if NOT FileExists(DatabasePath) Then Exit;
  FP := ExtractFilePath(DatabasePath);
  FN := ChangeFileExt(DatabasePath,'.ldb');
  if NOT FileExists(FN) Then Exit;
  F  := TFileStream.Create(FN,fmOpenRead);
  Sz := F.Size;
  SetLength(Tmp,F.Size);
  F.Read(Tmp,0,F.Size);
  F.Free;
  For X := 0 To (Sz DIV 64)-1 do
      Begin
        S   := AnsiEncoding.GetString(Tmp, X*64, 64);
        FP  := Copy(S,1,32);
        Delete(S,1,32);
        I   := Pos(#0,S);
        if I > 0 Then S := Copy(S,1,I-1);
        I   := Pos(#0,FP);
        if I > 0 Then FP := Copy(FP,1,I-1);
        FLoggedInfo.Add(FP+'/'+S);
      End;
  Result := True;
End;

Function TKADaoInfo.GetLoggedUsers : TStringList;
Begin
  if FActive Then KAGETLoggedUsers(FDatabase);
  Result := FLoggedUsers;
End;

Procedure TKADaoInfo.SetLoggedUsers(Value:TStringList);
Begin
 //****************************************************************** Read Onlly
End;

Function  TKADaoInfo.GetLoggedNowUsers : TStringList;
Begin
  if FActive Then KAGETLoggedNowUsers(FDatabase);
  Result := FLoggedNowUsers;
End;

Procedure TKADaoInfo.SetLoggedNowUsers(Value:TStringList);
Begin
 //****************************************************************** Read Onlly
End;

Function  TKADaoInfo.GetErrorUsers : TStringList;
Begin
  if FActive Then KAGETErrorUsers(FDatabase);
  Result := FErrorUsers;
End;

Procedure TKADaoInfo.SetErrorUsers(Value:TStringList);
Begin
 //****************************************************************** Read Onlly
End;

Function  TKADaoInfo.GetDatabaseVersion :Integer;
Begin
 Result:=0;
 if FActive Then Result:=KAGETDatabaseVersion(FDatabase);
 if Result < 0 Then Result:=0;
End;

Procedure TKADaoInfo.SetDatabaseVersion (Value:Integer);
Begin
 //****************************************************************** Read Onlly
End;

Function TKADaoInfo.GetNumberOfUsers :Integer;
Begin
  Result:=0;
  if FActive Then Result:=KAGETNumberOfUsers(FDatabase);
  if Result < 0 Then Result:=0;
End;

Procedure  TKADaoInfo.SetNumberOfUsers (Value:Integer);
Begin
 //****************************************************************** Read Onlly
End;

Procedure  TKADaoInfo.SetLastError(Value:Integer);
Begin
 //****************************************************************** Read Onlly
End;

Procedure  TKADaoInfo.SetLastErrorText(Value:String);
Begin
 //****************************************************************** Read Onlly
End;

Function TKADaoInfo.GetLoggedUsersEx:TStringList;
Begin
 Result := FLoggedInfo;
 if FActive Then KAGetLoggedInfo(FDatabase);
End;

Procedure TKADaoInfo.SetLoggedUsersEx(Value:TStringList);
Begin
 //****************************************************************** Read Onlly
End;

procedure Register;
begin
  RegisterComponents('KA Dao Controls', [TKADaoInfo]);
end;

end.
